import{s as ge,o as ve,n as $e}from"../chunks/scheduler.defa9a21.js";import{S as ye,i as be,g as c,s as l,r as J,A as Te,h as o,f as a,c as s,j as fe,u as K,x as p,k as ue,y as we,a as r,v as N,d as Q,t as V,w as Z}from"../chunks/index.fe795e71.js";import{T as _e}from"../chunks/Tip.179eb360.js";import{H as Le,E as xe}from"../chunks/EditOnGithub.0f575778.js";function He(A){let n,d=`Synchronization of the main torch (or CUDA or XLA) random number generator will affect any other potential random
artifacts you could have in your dataset (like random data augmentation) in the sense that all processes will get
the same random numbers from the torch random modules (so will apply the same random data augmentation if it’s
controlled by torch).`;return{c(){n=c("p"),n.textContent=d},l(i){n=o(i,"P",{"data-svelte-h":!0}),p(n)!=="svelte-1pu9s3f"&&(n.textContent=d)},m(i,h){r(i,n,h)},p:$e,d(i){i&&a(n)}}}function Me(A){let n,d=`The randomization part of your custom sampler, batch sampler or iterable dataset should be done using a local
<code>torch.Generator</code> object (in PyTorch &gt;= 1.6), see the traditional <code>RandomSampler</code>, as an example.`;return{c(){n=c("p"),n.innerHTML=d},l(i){n=o(i,"P",{"data-svelte-h":!0}),p(n)!=="svelte-1ffnyf3"&&(n.innerHTML=d)},m(i,h){r(i,n,h)},p:$e,d(i){i&&a(n)}}}function Pe(A){let n,d,i,h,u,k,_,ee=`Internally, 🤗 Accelerate works by first analyzing the environment in which the script is launched to determine which
kind of distributed setup is used, how many different processes there are and which one the current script is in. All
that information is stored in the <code>~AcceleratorState</code>.`,S,$,te=`This class is initialized the first time you instantiate an <a href="/docs/accelerate/pr_2845/en/package_reference/accelerator#accelerate.Accelerator">~Accelerator</a> as well as performing any
specific initialization your distributed setup needs. Its state is then uniquely shared through all instances of
<a href="/docs/accelerate/pr_2845/en/package_reference/state#accelerate.state.AcceleratorState">AcceleratorState</a>. (The same can also be done with the <a href="/docs/accelerate/pr_2845/en/package_reference/state#accelerate.PartialState">PartialState</a>, a more barebones version it inherits)`,z,g,ae='Then, when calling <a href="/docs/accelerate/pr_2845/en/package_reference/accelerator#accelerate.Accelerator.prepare">prepare()</a>, the library:',D,v,re='<li>wraps your model(s) in the container adapted for the distributed setup,</li> <li>wraps your optimizer(s) in an <a href="/docs/accelerate/pr_2845/en/package_reference/torch_wrappers#accelerate.optimizer.AcceleratedOptimizer">AcceleratedOptimizer</a>,</li> <li>wraps your scheduler(s) in an <a href="/docs/accelerate/pr_2845/en/package_reference/torch_wrappers#accelerate.scheduler.AcceleratedScheduler">AcceleratedScheduler</a></li> <li>creates a new version of your dataloader(s) in a <a href="/docs/accelerate/pr_2845/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderShard">DataLoaderShard</a> or <a href="/docs/accelerate/pr_2845/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderDispatcher">DataLoaderDispatcher</a></li>',E,y,ne=`While the model(s), optimizer(s), and scheduler(s) are just put in simple wrappers, the dataloader(s) are re-created. This is mostly
because PyTorch does not let the user change the <code>batch_sampler</code> of a dataloader once it’s been created and the
library handles the sharding of your data between processes by changing that <code>batch_sampler</code> to yield every other
<code>num_processes</code> batches (if enabled).`,q,b,le='The <a href="/docs/accelerate/pr_2845/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderShard">DataLoaderShard</a> subclasses <code>DataLoader</code> to add the following functionality:',U,T,se=`<li>it synchronizes the appropriate random number generator of all processes at each new iteration, to ensure any
randomization (like shuffling) is done the exact same way across processes.</li> <li>it puts the batches on the proper device before yielding them (unless you have opted out of
<code>device_placement=True</code>).</li>`,j,w,ie='The <a href="/docs/accelerate/pr_2845/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderDispatcher">DataLoaderDispatcher</a> subclasses differs from the <a href="/docs/accelerate/pr_2845/en/package_reference/torch_wrappers#accelerate.data_loader.DataLoaderShard">DataLoaderShard</a> in that when iterating through the <code>DataLoader</code>, the data is all starting from process 0 and <em>then</em> split and sent off to each process rather than it happening at the dataset level.',I,L,ce="The random number generator synchronization will by default synchronize:",O,x,oe="<li>the <code>generator</code> attribute of a given sampler (like the PyTorch <code>RandomSampler</code>) for PyTorch &gt;= 1.6</li> <li>the main random number generator in PyTorch &lt;=1.5.1</li>",R,H,pe=`You can choose which random number generator(s) to synchronize with the <code>rng_types</code> argument of the main
<a href="/docs/accelerate/pr_2845/en/package_reference/accelerator#accelerate.Accelerator">Accelerator</a>. In PyTorch &gt;= 1.6, it is recommended to rely on a local <code>generator</code> to avoid
setting the same seed in the main random number generator in all processes.`,G,m,F,f,W,M,de='For more details about the internals, see the <a href="package_reference/torch_wrappers">Internals page</a>.',X,P,Y,C,B;return u=new Le({props:{title:"🤗 Accelerate’s internal mechanisms",local:"-accelerates-internal-mechanisms",headingTag:"h1"}}),m=new _e({props:{warning:!0,$$slots:{default:[He]},$$scope:{ctx:A}}}),f=new _e({props:{$$slots:{default:[Me]},$$scope:{ctx:A}}}),P=new xe({props:{source:"https://github.com/huggingface/accelerate/blob/main/docs/source/concept_guides/internal_mechanism.md"}}),{c(){n=c("meta"),d=l(),i=c("p"),h=l(),J(u.$$.fragment),k=l(),_=c("p"),_.innerHTML=ee,S=l(),$=c("p"),$.innerHTML=te,z=l(),g=c("p"),g.innerHTML=ae,D=l(),v=c("ul"),v.innerHTML=re,E=l(),y=c("p"),y.innerHTML=ne,q=l(),b=c("p"),b.innerHTML=le,U=l(),T=c("ul"),T.innerHTML=se,j=l(),w=c("p"),w.innerHTML=ie,I=l(),L=c("p"),L.textContent=ce,O=l(),x=c("ul"),x.innerHTML=oe,R=l(),H=c("p"),H.innerHTML=pe,G=l(),J(m.$$.fragment),F=l(),J(f.$$.fragment),W=l(),M=c("p"),M.innerHTML=de,X=l(),J(P.$$.fragment),Y=l(),C=c("p"),this.h()},l(e){const t=Te("svelte-u9bgzb",document.head);n=o(t,"META",{name:!0,content:!0}),t.forEach(a),d=s(e),i=o(e,"P",{}),fe(i).forEach(a),h=s(e),K(u.$$.fragment,e),k=s(e),_=o(e,"P",{"data-svelte-h":!0}),p(_)!=="svelte-13gim1o"&&(_.innerHTML=ee),S=s(e),$=o(e,"P",{"data-svelte-h":!0}),p($)!=="svelte-e37u76"&&($.innerHTML=te),z=s(e),g=o(e,"P",{"data-svelte-h":!0}),p(g)!=="svelte-4qhnga"&&(g.innerHTML=ae),D=s(e),v=o(e,"UL",{"data-svelte-h":!0}),p(v)!=="svelte-1r2vi7d"&&(v.innerHTML=re),E=s(e),y=o(e,"P",{"data-svelte-h":!0}),p(y)!=="svelte-1xlmls8"&&(y.innerHTML=ne),q=s(e),b=o(e,"P",{"data-svelte-h":!0}),p(b)!=="svelte-s0evt3"&&(b.innerHTML=le),U=s(e),T=o(e,"UL",{"data-svelte-h":!0}),p(T)!=="svelte-zg63ut"&&(T.innerHTML=se),j=s(e),w=o(e,"P",{"data-svelte-h":!0}),p(w)!=="svelte-123qtsd"&&(w.innerHTML=ie),I=s(e),L=o(e,"P",{"data-svelte-h":!0}),p(L)!=="svelte-rp8jqi"&&(L.textContent=ce),O=s(e),x=o(e,"UL",{"data-svelte-h":!0}),p(x)!=="svelte-1nv6po7"&&(x.innerHTML=oe),R=s(e),H=o(e,"P",{"data-svelte-h":!0}),p(H)!=="svelte-b8dxxa"&&(H.innerHTML=pe),G=s(e),K(m.$$.fragment,e),F=s(e),K(f.$$.fragment,e),W=s(e),M=o(e,"P",{"data-svelte-h":!0}),p(M)!=="svelte-1hmhnse"&&(M.innerHTML=de),X=s(e),K(P.$$.fragment,e),Y=s(e),C=o(e,"P",{}),fe(C).forEach(a),this.h()},h(){ue(n,"name","hf:doc:metadata"),ue(n,"content",Ae)},m(e,t){we(document.head,n),r(e,d,t),r(e,i,t),r(e,h,t),N(u,e,t),r(e,k,t),r(e,_,t),r(e,S,t),r(e,$,t),r(e,z,t),r(e,g,t),r(e,D,t),r(e,v,t),r(e,E,t),r(e,y,t),r(e,q,t),r(e,b,t),r(e,U,t),r(e,T,t),r(e,j,t),r(e,w,t),r(e,I,t),r(e,L,t),r(e,O,t),r(e,x,t),r(e,R,t),r(e,H,t),r(e,G,t),N(m,e,t),r(e,F,t),N(f,e,t),r(e,W,t),r(e,M,t),r(e,X,t),N(P,e,t),r(e,Y,t),r(e,C,t),B=!0},p(e,[t]){const he={};t&2&&(he.$$scope={dirty:t,ctx:e}),m.$set(he);const me={};t&2&&(me.$$scope={dirty:t,ctx:e}),f.$set(me)},i(e){B||(Q(u.$$.fragment,e),Q(m.$$.fragment,e),Q(f.$$.fragment,e),Q(P.$$.fragment,e),B=!0)},o(e){V(u.$$.fragment,e),V(m.$$.fragment,e),V(f.$$.fragment,e),V(P.$$.fragment,e),B=!1},d(e){e&&(a(d),a(i),a(h),a(k),a(_),a(S),a($),a(z),a(g),a(D),a(v),a(E),a(y),a(q),a(b),a(U),a(T),a(j),a(w),a(I),a(L),a(O),a(x),a(R),a(H),a(G),a(F),a(W),a(M),a(X),a(Y),a(C)),a(n),Z(u,e),Z(m,e),Z(f,e),Z(P,e)}}}const Ae='{"title":"🤗 Accelerate’s internal mechanisms","local":"-accelerates-internal-mechanisms","sections":[],"depth":1}';function Ce(A){return ve(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ee extends ye{constructor(n){super(),be(this,n,Ce,Pe,ge,{})}}export{Ee as component};
